;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Ave Cruce Salus Mea
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; program: Win3ds10 - *.3ds / *.asc files viewer + demonstration of
;;          several graphics effects + tiny based on Bezier curves,
;;          3d objects editor.
;; author:  Maciej Guba aka macgub
;; web   :  www.macgub.hekko.pl
;; email :  macgub3@wp.pl
;; This application don't uses any 3d graphic library
;; (OGL, GTK, ..etc). Written from scratch in pure assembler. Thanks
;; to all, who was helping me to do it.
;; Program needs SSE2, SSE3, SSE4.1 or AVX extension.
;; Coding style is rather not perfect. Other words it's my own mess.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Key description :
;;          SPACE -  switching beetwen displaying  models: flat,
;;             smooth shading, spherical environment, texture, bump,
;;             smooth + texture, two texture and bump + texture
;;             mapping pararell, edges only (smooth shaded, textured
;;             lines), flat with float single precision Z coordinate;
;;          TAB - generate three unlinear directional lights (Phongs
;;             illumination);
;;          F1 - motion blur on/off;
;;          F2 - cyclic switching between objects (from file and
;;             predefined: heart (Sanctissimi Cordis Christi) and
;;             tetrahedron), also turning on edit rotary Bezier object
;              option - ( Setting object parameters:
;;             green line with  blue begin and end - rotary arbitrary
;;             vector, green lines with red bars - derives, to change
;;             derives  and arbitrary vector move cursor on red, or blue
;;             bar, press left button on it and move mouse. Currently
;;             edited object will be  show on the fly. Rotate independent
;;             current segment of Bezier solid, marked with green frame,
;;             by pressing and moving left mouse button on main view
;;             window. Rotating independent segment around its center
;;             point.); Also Bezier pipes editing option - (editing
;;             pipes like in previous rotary object, but rotatry vector,
;;             in this editing option its lenght determines Bezier pipes
;;             radius, also independent pipe segment rotating around its
;;             center point are implemented); Also rotated solids and
;;             pipes pararell drawing possibility, editing options like
;;             in previous causes. As I wrote, switching beetwen editing
;;             options by pressing F2;
;;          F3/F4(+/-) keys - zoom in/out;
;;          F5 - choose   bumps also texture mapping planar or
;;             spherical (planar according to axis X, Y, Z);
;;          F6 - switching between random bumps and texture dependent;
;;          F7 - select  texture: red white stripes, xored face and blank -
;;              witch can by used in smoothing objects edges
;;          F8 - save 3d currently shown object to file "object.asc" and
;;             "object.3ds";
;;          F9 - in Bezier rotated solid  option, also pipes and rotated
;;             solids & pipes pararell - cyclic switching between current
;;             segment, current segment marked by green frame in two last
;;             editing options not works correct for now ;
;;          F11 - main rotary on/off;
;;          F12 - main rotary cyclic switching - around axis X, Y, Z;
;;          D   - do displacement mapping texture dependent;
;;          T   - triangulize all objects faces - it's mean divide each
;;                face to four smaller faces;
;;          X   - load texture (raw format 512X512 pixels 24bit 0xRRGGBB)
;;          ESC - exit;
;;          Right mouse button and move - setting position of texture,
;;                (works in all drawing models, but is visable only in
;;                texture displaying models).
;;
;;          After run program shows dialog to open file.
;;          Choose file in 3ds or asc format and ...admire. ;)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

format PE GUI 4.0
entry start

include '/include/win32a.inc'
BSEGMENTS = 2	    ; Bezier curve segments count
BPIPES = 1	    ; Bezier pipes count (only in solid and pipes
		    ; pararell editing cause.
BROTSOLIDS =  BSEGMENTS - BPIPES
BXRES	 equ 400 ;1600 ;1200 ;800      ;choose window size of bezier curve editor area
BYRES	 equ 400 ; 900 ; 675 ;450
BSIZE_X  equ BXRES
BSIZE_Y  equ BYRES
BROUND	 equ 8

BROTARY_STEPS = BSTEPS	 ; BROTARY_STEPS and BSTEPS  must have the same
		     ; value (both determines object quality|)
BSTEPS = 24


;XRES = 600 ;800 ;1600 ;1200 ;800      ;choose screen size
;YRES = 600  ;450 ;900 ; 675 ;450
;SIZE_X  = XRES
;SIZE_Y  = YRES
TEX_X = 512    ; texture size
TEX_Y = 512
TEXTURE_SIZE EQU (TEX_X * TEX_Y)-1
TEX_SHIFT = 9
TRIANGLES_COUNT equ 4
POINTS_COUNT equ 4
MAX_COUNTER equ 16    ; b_surface.inc  - determines triangles count
ROUND equ 8
NON  = 0  ; --\
MMX  = 1  ;    > this definitions are only for upside down
SSE  = 2  ; --/  compatible reasons
SSE2 = 3
SSE3 = 4
SSE4.1 = 5
AVX = 6
AVX2 = 7
Ext  =	SSE2
HEAP_MAX_SIZE = 1024 * 1024 * 20 ;1024  ; = 1GB address space.


section '.text' code readable executable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; start and message loop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start:

    invoke GetModuleHandle,0
    mov [wc.hInstance],eax
    invoke LoadIcon,0,IDI_APPLICATION
    mov [wc.hIcon],eax
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

     invoke  GetSystemMetrics,SM_CXSCREEN
     mov     ebx,eax
     mov     [xres_var],ax
 ;    sub     [xres_var],160
     shr     eax,1
     mov     [xxadd],eax
     invoke  GetSystemMetrics,SM_CYSCREEN
     mov     [yres_var],ax
     sub     [yres_var],100
     mov     ecx,eax
     shr     ecx,1
     mov     [yyadd],ecx

     lea     ecx,[ebx-3]
     cvtsi2ss xmm0,ecx
     movss   [max_clip_seg],xmm0
     lea     ecx,[eax-3]
     cvtsi2ss xmm0,ecx
     movss   [max_clip_seg+4],xmm0


     mul     ebx
     shl     eax,2
     mov     ebx,eax
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:

    mov     [screen_ptr],eax
    mov     [line_buffer_var],eax
    mov     [lbuffer_ptr],eax

    invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
    mov     [Zbuffer_ptr],eax

    mov   [bmi.biSize],sizeof.BITMAPINFOHEADER
    movzx eax,[xres_var]
    mov   [bmi.biWidth],eax  ;XRES
    movzx edx,[yres_var]

    neg   edx
    sub   edx,30
    mov [bmi.biHeight],edx ;-YRES-30
    mov [bmi.biPlanes],1
    mov [bmi.biBitCount],32
    mov [bmi.biCompression],BI_RGB

    mov [bmi.biSizeImage],0
    mov [bmi.biXPelsPerMeter],0
    mov [bmi.biYPelsPerMeter],0
    mov [bmi.biClrUsed],0
    mov [bmi.biClrImportant],0

    mov [rect.left],0
    mov [rect.top],0
    mov [rect.right],eax ;XRES+0
    movzx edx,[yres_var]
    add   edx,30
;    neg edx
    mov   [rect.bottom],edx ;YRES+30


    mov [Bbmi.biSize],sizeof.BITMAPINFOHEADER
    mov [Bbmi.biWidth],BXRES
    mov [Bbmi.biHeight],-BYRES-30
    mov [Bbmi.biPlanes],1
    mov [Bbmi.biBitCount],32
    mov [Bbmi.biCompression],BI_RGB

    mov [Bbmi.biSizeImage],0
    mov [Bbmi.biXPelsPerMeter],0
    mov [Bbmi.biYPelsPerMeter],0
    mov [Bbmi.biClrUsed],0
    mov [Bbmi.biClrImportant],0


    invoke AdjustWindowRect,rect,WS_POPUP or WS_SYSMENU or WS_CAPTION,0

    invoke RegisterClass,wc



    mov ecx,[rect.bottom]
    mov eax,[rect.right]
    sub ecx,[rect.top]
    sub eax,[rect.left]
    ; rasizable window
    invoke  CreateWindowEx, 0,_class, _title, WS_VISIBLE + WS_OVERLAPPEDWINDOW,\
				0, 0, eax, ecx, NULL, NULL, [wc.hInstance], NULL

;    invoke  CreateWindowEx, 0,_class, _title, WS_VISIBLE + WS_OVERLAPPEDWINDOW,\
;                                CW_USEDEFAULT, CW_USEDEFAULT, eax, ecx, NULL, NULL, [wc.hInstance], NULL
    ; non resizable window
 ;   invoke CreateWindowEx,0,_class,_title,WS_OVERLAPPEDWINDOW\
 ;          xor WS_THICKFRAME xor WS_MAXIMIZEBOX,0,0,eax,ecx,NULL,NULL,0,0
    mov [hwnd],eax
    invoke GetDC,[hwnd]
    mov [hdc],eax
    invoke ShowWindow,[hwnd],SW_SHOW



    pushad
    movzx  eax,[yres_var]  ;YRES / 2
    shr    eax,1
    cvtsi2ss xmm0,eax
    movss  [scale],xmm0

    mov    edi,segments_rotary	 ; zero segment add struct
    xor    eax,eax
    mov    ecx,BSEGMENTS*3
    cld
    rep    stosd


    mov    edi,segments_add	; zero segments add struct
    xor    eax,eax
    mov    ecx,BSEGMENTS*3
    rep    stosd


    call   Binit_derives

    call   open_file
 ;   call   open_texture
    cmp    [file_ext_flag],0
    jne    @f
    call   read_from_file     ; 3ds
    jmp    .norm
  @@:
;    cmp    [file_ext_flag],1
    call   read_asc		; asc
  .norm:
    pushad
    push   dword points_r
    movzx  ecx,[points_count_var]
    push   ecx
    call   normalize_object1
    popad

    call   init_triangles_normals2
    call   init_point_normals
    call   normalize_all_light_vectors
    call   init_envmap2
    call   do_color_buffer
    mov    edi,bump_map
    call   calc_bumpmap
    call   calc_bumpmap_coords
    call   generate_texture2

    popad

msg_loop:
    stdcall g_draw
    mov  eax,[ccounter_inc]

    cmp   [rotary_flag],0
    jne   @f
    add   dword[main_rotary],eax
    and   dword[main_rotary],0xff
    jmp   .end_rot_inc
  @@:
    cmp   [rotary_flag],1
    jne   @f
    add   dword[main_rotary+4],eax
    and   dword[main_rotary+4],0xff
    jmp   .end_rot_inc
  @@:
    cmp   [rotary_flag],2
    jne   @f
    add   dword[main_rotary+8],eax
    and   dword[main_rotary+8],0xff
;    jmp   .end_rot_inc
  @@:

  .end_rot_inc:

    cmp  [hrt_flag],3		 ; hrt_flag indicates what object is current
    jl	 @f
    movzx  eax,[xres_var]
    movzx  ebx,[yres_var]
    mov  ecx,eax
    mov  edx,ebx
    sub  ecx,BXRES
    add  edx,30


;    invoke StretchDIBits,[hdc],0,30,XRES-BXRES,YRES+30,0,0,XRES,YRES,[screen_ptr],bmi,0,SRCCOPY
    invoke StretchDIBits,[hdc],0,30,ecx,edx,0,0,eax,ebx,[screen_ptr],bmi,0,SRCCOPY
    call   Bdraw_all
    movzx  eax,[xres_var]
    movzx  ebx,[yres_var]
    mov    ecx,eax
    sub    ecx,BXRES
    mov    edx,ebx
    sub    edx,BYRES-30

;    invoke StretchDIBits,[hdc],XRES-BXRES,YRES-BYRES+30,BXRES,BYRES,0,0,BXRES,BYRES,Bbuffer,Bbmi,0,SRCCOPY
     invoke StretchDIBits,[hdc],ecx,edx,BXRES,BYRES,0,0,BXRES,BYRES,Bbuffer,Bbmi,0,SRCCOPY
    jmp  .no_editor

  @@:


     movzx    eax,[xres_var]
     movzx    ebx,[yres_var]
     mov      ecx,ebx
     add      ecx,30
     invoke   StretchDIBits,[hdc],0,30,eax,ecx,0,0,eax,ebx,[screen_ptr],bmi,0,SRCCOPY
;          invoke StretchDIBits,[hdc],0,30,XRES,YRES+30,0,0,XRES,YRES,[screen_ptr],bmi,0,SRCCOPY
 .no_editor:
    movzx  eax,[draw_flag]
    mov    ebx,36
    mul    ebx
    add    eax,sh_model
    invoke TextOut,[hdc],10,10,eax,36


    invoke Sleep,2

    invoke PeekMessage,msg,0,0,0,PM_NOREMOVE
    or eax,eax
    je msg_loop

    invoke GetMessage,msg,NULL,0,0
    or eax,eax
    je end_loop

    invoke TranslateMessage,msg
    invoke DispatchMessage,msg
    jmp msg_loop

error:
    invoke MessageBox,NULL,_error,NULL,MB_ICONERROR+MB_OK

end_loop:

     movzx    ebx,[xres_var]
     movzx    eax,[yres_var]
     mul      eax
     shl      eax,2
;     imul   ebx,[yres_var]
;     shl    ebx,2
     invoke  VirtualFree,[screen_ptr], eax, MEM_DECOMMIT


    invoke ReleaseDC,[hwnd],[hdc]
    invoke DestroyWindow,[hwnd]
    invoke ExitProcess,[msg.wParam]

mem_alloc_heap:
; in eax - size

	push	ecx edx
	invoke	VirtualAlloc, [heap_start_ptr], eax, MEM_COMMIT, PAGE_EXECUTE_READWRITE
	test	eax, eax
	jz	.error_VirtualAlloc
	clc
	pop	edx ecx
	ret
     .error_VirtualAlloc:
	int3
	xor	eax,eax
	stc
	pop	edx ecx
	ret

mem_free_heap: ;.block, .size
;   eax -  block
;   ebx -  size

	 push	 ecx edx eax

	 invoke  VirtualFree, eax, ebx, MEM_DECOMMIT
	 test	 eax, eax
	 jz	 .error

	 clc
	 pop	 eax edx ecx
	 ret
   .error: stc
	 xor	eax,eax
	 int3
	 ret






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WindowProc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc WindowProc uses ebx esi edi, hwnd,wmsg,wparam,lparam
    cmp [wmsg],WM_KEYDOWN
    je .wmkeydown
   @@:
     cmp   [wmsg],WM_LBUTTONDOWN
     jne   .next_mess345
     cmp   [hrt_flag],3
     jl    .next_mess345
     mov   eax,[lparam]
     sub   ax,[xres_var]  ;XRES-BXRES
     add   ax,BXRES
     ror   eax,16
     sub   ax,[yres_var]  ;YRES+30-BYRES
     sub   ax,30-BYRES
     ror   eax,16
     cmp   ax,[yres_var]  ;BYRES
     jg    @f
     cmp   ax,0
     jl    @f
     ror   eax,16
     cmp   ax,BXRES
     jg    @f
     cmp   ax,0
     jl    @f
     ror   eax,16


     movzx ebx,ax
     shr   eax,16
     mov   edx,BXRES
     mul   edx
     add   eax,ebx
     shl   eax,2
     add   eax,Bbuffer
     mov   ebx,[eax]
     and   ebx,0xff000000
     cmp   ebx,0xff000000
     je    .next_mess345
     shr   ebx,24
     mov   [Bcrucial_point],ebx
     mov   [Bmove_flag],1
     jmp   .next_mess345
  @@:
     cmp   [current_seg],255
     je    @f
    if 0
     mov   eax,[lparam]
     ror   eax,16
     sub   ax,30

     cmp   ax,[yres_var] ;YRES
     jg    @f
     cmp   ax,0
     jl    @f
     ror   eax,16
     cmp   ax,[xres_var]  ;XRES
     jg    @f
     cmp   ax,0
     jl    @f
   end if
     mov   [seg_rot_flag_button_down],1
  @@:
   .next_mess345:
     cmp   [wmsg],WM_MOUSEMOVE
      jne   .next_msg
;     cmp   [hrt_flag],3
;     jl    @f
;     cmp   [current_seg_add_flag],1     ; note - too paranoid seg_add work
;     jne    .Bezier_mov @f

;   @@:
     cmp   [seg_rot_flag_button_down],1
     jne   .Bezier_mov
     cmp   [hrt_flag],3
     jge   @f
     jmp   .Bezier_mov
   ;  cmp   [hrt_flag],4
   ;  jne   .Bezier_mov
   @@:
     mov   eax,[lparam]    ; rotate single segment of bezier
					    ; rotated solid
     ror   eax,16
     sub   ax,30
     movzx ebx,ax
     shr   eax,16
     movzx ecx,[current_seg]
     shl   ecx,2
     lea   ecx,[ecx*3]
     and   eax,0xff
     and   ebx,0xff
     mov   [segments_rotary+ecx],eax
     mov   [segments_rotary+ecx+4],ebx
     pushad
     call  Bdraw_all
     popad
     cmp   [hrt_flag],3
     jne   @f
     call  save_object
     jmp   .Bezier_mov
   @@:
     cmp   [hrt_flag],4
     jne   @f
     call  save_pipe
     jmp   .Bezier_mov
   @@:
     call  save_pipe_rot_solid
   .Bezier_mov:
     cmp   [Bmove_flag],1
     jne   .next_msg
     mov   ecx,[lparam]
     mov   ax,[xres_var]
     sub   ax,BXRES
     cmp   cx,ax  ;XRES-BXRES
     jl    .next_msg
     ror   ecx,16
     mov   bx,[yres_var]
     add   bx,30-BYRES
     cmp   cx,bx  ;YRES+30-BYRES
     jl    .next_msg
     sub   cx,bx   ;YRES+30-BYRES
     ror   ecx,16
     sub   cx,ax   ;XRES-BXRES

     mov   ebx,[Bcrucial_point]
     cmp   ebx,253		   ; check if axis
     jae   @f
     shl   ebx,2
     mov   [ebx+Biderives],ecx
     jmp   .draw
    @@:
     sub   ebx,253
     shl   ebx,2
     mov   [ebx+Bix1_axis],ecx
   .draw:
     pushad
     call  Bdraw_all
     popad
     cmp   [hrt_flag],4
     jne   @f
     call save_pipe	   ; save changes - on the fly write to points / triangles lists
     jmp  .next_msg
   @@:
     cmp  [hrt_flag],5
     jne  @f
;     pushad
;     call  Bdraw_all
;     popad
     call    save_pipe_rot_solid
     jmp  .next_msg
   @@:
;     pushad
;     call  Bdraw_all
;     popad
     call  save_object	 ; if hrt_flag = 3 save solid rotared curve


  .next_msg:
     cmp   [wmsg],WM_LBUTTONUP
     jne   @f
     mov   [seg_rot_flag_button_down],0
     mov   [Bmove_flag],0

  @@:

    cmp   [wmsg],WM_RBUTTONDOWN
    jne   @f
    mov   [tex_button_pres],1
    mov   eax,[lparam]
    mov   [tex_mov_begin_x],eax
 ;   shr   eax,16
 ;   mov   [tex_mov_begin_y],ax
  @@:
    cmp   [wmsg],WM_RBUTTONUP
    jne   @f
    mov   [tex_button_pres],0
    jmp   .next_1
  @@:

    cmp    [wmsg],WM_MOUSEMOVE
    jne    @f
    cmp    [tex_button_pres],1
    jne    @f

    movd   xmm0,[lparam]
    movd   xmm1,[tex_mov_begin_x]

    psubw  xmm1,xmm0
    movd   eax,xmm1
    movd   [tex_mov_begin_x],xmm0
    mov    ebx,eax
    sar    ebx,16
    cwde
    call   move_texture
   @@:
 .next_1:




















   @@:
    cmp [wmsg],WM_DESTROY
    je .wmdestroy
  .defwndproc:
    invoke DefWindowProc,[hwnd],[wmsg],[wparam],[lparam]
    jmp .finish
  .wmkeydown:
    cmp [wparam],VK_UP
    jne .vescape_or_set_shading

    xor eax,eax
    jmp .finish
  .vescape_or_set_shading:
    cmp [wparam],VK_SPACE
    jne .next_cmp
    inc [draw_flag]
    cmp [draw_flag],14
    jne  @f
    mov [draw_flag],0
   @@:
    movzx  eax,[xres_var]
    invoke StretchDIBits,[hdc],0,0,eax,30,0,0,1,1,fakebitmap,bmi,0,SRCCOPY
  .next_cmp:
    cmp   [wparam],VK_TAB
    jne   @f
    call  make_random_lights
    call  normalize_all_light_vectors
    call  do_color_buffer
    call  init_envmap2
  @@:
    cmp   [wparam],VK_F1
    jne   .next_wparam
    not   [blur_flag]

 @@:
;    jmp   .skip11
  .next_wparam:
    cmp   [wparam],VK_F2
    jne   .next_mes
    inc   [hrt_flag]
    cmp   [hrt_flag],6
    jne   @f
    mov   [hrt_flag],0
  @@:
    cmp   [hrt_flag],1
    jne   @f
    call  read_hrt
    jmp   .skip11
  @@:
    cmp   [hrt_flag],2
    jne    @f
    call   load_tetrahedron
    jmp   .skip11
  @@:
     cmp   [hrt_flag],3
     jne   @f
     pushad
  ;   mov   [scale],dword 1.0
     call  Bdraw_all
     popad
     call save_object	     ; save changes - on the fly write to points / triangles lists
     jmp   .skip11
 @@:
     cmp   [hrt_flag],4
     jne   @f
     pushad
;     mov    eax,YRES / 2
;     cvtsi2ss xmm0,eax
;     movss  [scale],xmm0
     call  Bdraw_all
     popad
     call save_pipe	   ; save changes - on the fly write to points / triangles lists
     jmp   .skip11
  @@:
     cmp   [hrt_flag],5
     jne   @f
     pushad
;     mov    eax,YRES / 2
;     cvtsi2ss xmm0,eax
;     movss  [scale],xmm0
     call  Bdraw_all
     popad
     call   save_pipe_rot_solid       ; save changes - on the fly write to points / triangles lists
     jmp   .skip11
  @@:
;  @@:
;     cmp   [hrt_flag],4
;     jne  @f
;     pushad
;     call  draw_curve
;     mov   [Bsave_flag],1
;     call  Bdraw_all
;     popad
;     call  save_pipe        ; save changes
;     jmp   .skip11
   @@:

;     cmp   [hrt_flag],5     ; do random bezier surface
;     jne  @f
;     pushad
;     call  calc_surface
;     call  do_triangles_list_surface
;     popad
;     jmp   .skip11
   @@:


    cmp    [file_ext_flag],0
    jne    @f
    pushad
    call   read_from_file
    popad
    jmp    .skip11
  @@:
    call   read_asc
  .skip11:

    pushad
    push   dword points_r
    movzx  ecx,[points_count_var]
    push   ecx
    call   normalize_object1
    call   init_triangles_normals2
    call   init_point_normals
    popad
    call   calc_bumpmap_coords
    jmp    .finish

  .next_mes:
    cmp   [wparam],VK_F3  ;ADD
    je	  @f

    cmp   [wparam],VK_ADD
    jne   .next_mes6
  @@:
    fninit
    fld   [scale]
    fmul  [scale_plus]
    fstp  [scale]
  .next_mes6:
    cmp   [wparam],VK_F4  ;SUBTRACT
    je	  @f
    cmp   [wparam],VK_SUBTRACT
    jne   .next_mes5
  @@:
    fninit
    fld   [scale]
    fmul  [scale_minus]
    fstp  [scale]
  .next_mes5:
    cmp   [wparam],VK_F5
  ;  mov   eax,[wparam]
  ;  int3
    jne   .next_mes2
    inc   [map_flag]	     ; bump, texture - spherical or planar mapping ?
    cmp   [map_flag],4
    jne   @f
    mov   [map_flag],0
  @@:
    call  calc_bumpmap_coords
  .next_mes2:
    cmp   [wparam],VK_F6
    jne   .next_mes3	      ; bumps - random or texture dependent ?
    inc   [bump_flag]
    cmp   [bump_flag],2
    jne   @f
    mov   [bump_flag],0
  @@:
    call  calc_bumpmap
  .next_mes3:
    cmp   [wparam],VK_F7
    jne   .next_mes4  ; bumps - random or texture dependent ?

    inc   [tex_flag]
    cmp   [tex_flag],3
    jne   @f
    mov   [tex_flag],0
  @@:
    cmp   [tex_flag],0
    jne   @f
    call  generate_texture2    ; draw stripes
    call  calc_bumpmap	       ; should I recreate bumps ?
    jmp   .next_mes4
  @@:
    cmp   [tex_flag],1
    jne   @f
    call  generate_texture3	; draw xor
    call  calc_bumpmap		; should I recrete bumps ?
    jmp   .next_mes4
  @@:
    call  generate_texture1
    call  calc_bumpmap
  .next_mes4:
    cmp   [wparam],VK_F8
    jnz   @f
    call  write_asc
    call  save3ds
  @@:
    cmp   [wparam],VK_F9
    jnz   .next_mesf11
    cmp   [hrt_flag],3
    jl	  .next_mesf11
    inc   [current_seg]
    cmp   [current_seg],BSEGMENTS
    jne   @f
    mov   [current_seg],0
  @@:
    pushad
    call  Bdraw_all
    popad
    cmp  [hrt_flag],3
    jne  @f
    call save_object
    jmp   .next_mesf11
  @@:
    cmp   [hrt_flag],4
    jne   @f
    call  save_pipe
    jmp   .next_mesf11
  @@:
    call  save_pipe_rot_solid
   .next_mesf11:
  @@:
    cmp   [wparam],VK_F11
    jnz   @f
    inc   [ccounter_inc]
    and   [ccounter_inc],1
  @@:
    cmp   [wparam],VK_F12
    jnz   @f
    add   [rotary_flag],1
    cmp   [rotary_flag],3
    jnae  @f
    mov   [rotary_flag],0
  @@:

    cmp  [wparam],0x44	;'D'
    jne  @f
    pushad
    call  apply_displacement_from_tex
    popad
    jmp   .skip11
  @@:

    cmp   [wparam],0x54 ;'T'
    jne    .next_mes13
    pushad
    call  triangulize_all_faces
    popad
    jmp   .skip11
  .next_mes13:
    cmp   [wparam],0x58 ;  'x'
    jne   .next_mes14
    call   open_texture
  .next_mes14:
    cmp   [wparam],VK_ESCAPE
    jne   .finish
  .wmdestroy:
    invoke PostQuitMessage,0
    xor eax,eax
  .finish:
    ret
endp
open_texture:

   mov	   [ofntex.Flags],OFN_FILEMUSTEXIST+OFN_PATHMUSTEXIST+OFN_EXPLORER
   invoke  GetOpenFileName,ofntex
   or	   eax,eax
   jz	   .cancel

   invoke  CreateFile,fnametex,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
   mov	   [hfiletex],eax
   cmp	   eax,-1
   je	   .failed
   invoke  GetFileSize,[hfiletex],0
   cmp	   eax,-1
   je	   .failed
   cmp	   eax,TEX_X*TEX_Y*3
   jnae    .failed
   mov	   [FileSize],eax
   cmp	   [pmemtex],0
   jne	   .heap_realloc
   invoke  GetProcessHeap
   mov	   [hheap],eax
   invoke  HeapAlloc,[hheap],0,[FileSize]
   jmp	   .read_file

 .heap_realloc:
   invoke  HeapReAlloc,[hheap],0,[pmem],[FileSize]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; read raw file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 .read_file:	  ; read texture
   mov	   [pmemtex],eax
   mov	   ebx,eax
   invoke  ReadFile,[hfiletex],[pmemtex],[FileSize],BytesRead,0
   or	   eax,eax
   jz	   .read_error
   invoke  CloseHandle,[hfiletex]
   mov	   [hfiletex],0

  ; mov     ecx,[BytesRead]
;   mov     cx,WORD [ebx]

   mov	   esi,ebx
   mov	   edi,texmap
   cld
;   push     eax
   mov	    ecx,TEX_X*TEX_Y  ;eax
;   shr      ecx,2
   xor	    eax,eax
 @@:
   movsw
   movsb
   stosb
   loop  @b
;   pop     eax
   mov	   eax,[BytesRead]
  .init_ptr:
   mov	   [File_tex_ptr],ebx
   invoke  InvalidateRect,[hwnd],0,1
   xor	   eax,eax
   ret


 .read_error:
   invoke  HeapFree,[hheap],0,[pmemtex]
   mov	   [pmemtex],0

 .failed:
   cmp	   [hfiletex],0
   je	   @f
   invoke  CloseHandle,[hfiletex]
  @@:
   invoke  MessageBox,[hwnd],_notraw,0,MB_OK
   .cancel:
  ; invoke ReleaseDC,[hwnd],[hdc]
  ; invoke DestroyWindow,[hwnd]
  ; invoke ExitProcess,[msg.wParam]
ret














open_file:

   mov	   [ofn.Flags],OFN_FILEMUSTEXIST+OFN_PATHMUSTEXIST+OFN_EXPLORER
   invoke  GetOpenFileName,ofn
   or	   eax,eax
   jz	   .cancel

   invoke  CreateFile,fname,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
   mov	   [hfile],eax
   cmp	   eax,-1
   je	   .failed
   invoke  GetFileSize,[hfile],0
   cmp	   eax,-1
   je	   .failed
   mov	   [FileSize],eax
   cmp	   [pmem],0
   jne	   .heap_realloc
   invoke  GetProcessHeap
   mov	   [hheap],eax
   invoke  HeapAlloc,[hheap],0,[FileSize]
   jmp	   .read_file

 .heap_realloc:
   invoke  HeapReAlloc,[hheap],0,[pmem],[FileSize]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; read 3ds file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 .read_file:
   mov	   [pmem],eax
   mov	   ebx,eax
   invoke  ReadFile,[hfile],[pmem],[FileSize],BytesRead,0
   or	   eax,eax
   jz	   .read_error
   invoke  CloseHandle,[hfile]
   mov	   [hfile],0

   mov	   eax,[BytesRead]
   mov	   cx,WORD [ebx]
   cmp	   cx,'MM'
   je	  @f
;   cmp     cx,'Am'
;   jne     .read_error
   mov	   [file_ext_flag],1  ; asc
   jmp	   .init_ptr
;  mov     edx,[ebx+2]
 @@:
   mov	   [file_ext_flag],0
  .init_ptr:
   mov	   [File_ptr],ebx
   invoke  InvalidateRect,[hwnd],0,1
   xor	   eax,eax
   ret


 .read_error:
   invoke  HeapFree,[hheap],0,[pmem]
   mov	   [pmem],0

 .failed:
   cmp	   [hfile],0
   je	   @f
   invoke  CloseHandle,[hfile]
  @@:
   invoke  MessageBox,[hwnd],_not3ds,0,MB_OK
   .cancel:
   invoke ReleaseDC,[hwnd],[hdc]
   invoke DestroyWindow,[hwnd]
   invoke ExitProcess,[msg.wParam]
ret


init_sincos:
;in:  ebx - ptr to integer marks of rotary
    fninit
    fild    dword[ebx]
    fmul   [one_deg]


    fsincos
    fst   dword[cos_x]
    fchs
    fstp  [neg_cos_x]
    fst   [sin_x]
    fchs
    fstp  [neg_sin_x]


    fild   dword[ebx+4]
    fmul   [one_deg]
    fsincos
    fst   dword[cos_y]
    fchs
    fstp  [neg_cos_y]
    fst   [sin_y]
    fchs
    fstp  [neg_sin_y]
    fild   dword[ebx+8]
    fmul   [one_deg]
    fsincos
    fst   dword[cos_z]
    fchs
    fstp  [neg_cos_z]
    fst   [sin_z]
    fchs
    fstp  [neg_sin_z]
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; g_draw - draw to screen buffer; main program proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc g_draw ;uses ebx esi edi
local .temp dw ?, .rot_flag dw ?
;local .first_p_index dd ?, .second_p_index dd ?, .third_p_index dd ?
;local .zz1 dw ?, .zz2 dw ?, .zz3 dw ? ;-> don't change order
local .zz1f dd ?, .zz2f dd ?, .zz3f dd ?
local .xx1 dw ?, .xx2 dw ?, .xx3 dw ?
local .yy1 dw ?, .yy2 dw ?, .yy3 dw ?
local .xy1 dd ?, .xy2 dd ?, .xy3 dd ?
local .dpr dd ?, .dpr_p dd ?
local .x_temp_var dd ?, .y_temp_var dd ?
local .counter dd ?
local .sinx dd ?, .cosx dd ?
local .siny dd ?, .cosy dd ?
local .sinz dd ?, .cosz dd ?
local .matrix rb 36
    pushad
    cmp   [blur_flag],0
    jne   @f
    xor   eax,eax	   ; clear draw buffer
    mov   edi,[screen_ptr]
    cld
;    mov  ecx,XRES * YRES
    movzx ebx,[xres_var]
    movzx ecx,[yres_var]
    imul  ecx,ebx
    rep   stosd
    jmp   .no_blur
  @@:
    mov   ecx,1
    call  blur_screen
  .no_blur:
    cmp   [draw_flag],10
    je	  @f
    mov   eax,5000*65536    ; make background to Zbuffer
    jmp   .m_back
  @@:
    mov   eax,6000.1
  .m_back:
    mov   edi,[Zbuffer_ptr]
;    mov   ecx,XRES * YRES
    movzx ecx,[xres_var]
    movzx ebx,[yres_var]
    imul  ecx,ebx
    rep   stosd


  .rotate:
if 1
 ;  cmp [rotary_flag],2
 ;
 ;  jnl .classic_rot

   fninit
 ;  fldpi
 ;  fidiv [i180]
   fld	 [one_deg]
   fld	 st
   fimul dword[main_rotary+8]	; z
   fsincos
   fstp  [.sinx]
   fstp  [.cosx]
   fld	 st
   fimul dword[main_rotary] ; x
   fsincos
   fstp  [.siny]
   fstp  [.cosy]
   fimul dword[main_rotary+4] ; y
   fsincos
   fstp  [.sinz]
   fstp  [.cosz]

   pushad
   push   [.sinx]
   push   [.cosx]
   push   [.siny]
   push   [.cosy]
   push   [.sinz]
   push   [.cosz]
   lea	  edi,[.matrix]
   call   make_rotation_matrix
   ; edi -  desired matrix
   popad

   push   ebp
   mov	  esi,points_normals	       ; rotate normals
   mov	  edi,points_normals_rotated
   movzx  ecx,[points_count_var]
   lea	  ebx,[.matrix]
   call   rotary
   pop ebp


   push   ebp


   lea	esi,[.matrix] ;esi - pointer to 3x3 matrix
   mov	ebx,scale     ;ebx - ptr to scale
   call add_scale_to_matrix


   lea	  ebx,[.matrix]
   movzx  ecx,[points_count_var]
   mov	  esi,points_r
   mov	  edi,points_rotated
   call   rotary
   pop	  ebp
;   jmp    .draw
end if
; .classic_rot:
;    mov  ebx,main_rotary
;    call init_sincos
if 0

 .skip2:
    mov    [.rot_flag],0
 .rot_points_and_normals:
    mov    esi,points_r 	; rotate points
    mov    edi,points_rotated
    movzx  ecx,[points_count_var]
    mov    ebx,cos_x
    call   classic_rotor

    mov    esi,points_normals		; rotate normals
    mov    edi,points_normals_rotated
    movzx  ecx,[points_count_var]
    mov    ebx,cos_x
    call   classic_rotor
end if


    ; scale and set in center of window
    ; add  to cur rotated segment solid offset



 ;   movss    xmm2,[scale]
 ;   shufps   xmm2,xmm2,0
    movdqu   xmm3,[xxadd]
    cvtdq2ps xmm3,xmm3
    movzx    ecx,[points_count_var]
    mov      ebx,points_rotated
 @@:
    movups   xmm1,[ebx]
 ;   mulps    xmm1,xmm2
    addps    xmm1,xmm3
    movlps   [ebx],xmm1
    movhlps  xmm1,xmm1
    movss    [ebx+8],xmm1
    add      ebx,12
    sub      ecx,1
    jnz      @b

if 0
    mov   ebx,BSTEPS*BSTEPS*12
    movzx eax,[current_seg]
    mul   ebx
    mov   esi,eax
    add   esi,points_rotated
    mov   ecx,BSTEPS*BSTEPS

    movups   xmm0,[current_seg_add] ; x,y,z
    cvtdq2ps xmm0,xmm0

  @@:
    movups   xmm1,[esi]
    addps    xmm1,xmm0

    movlps   [esi],xmm1
    movhlps  xmm1,xmm1
    movss    [esi+8],xmm1
    add      esi,12
    sub      ecx,1
    jnz      @b
end if

 .draw:
    mov   esi,triangles 	   ; draw triangles
    movzx ecx,[triangles_count_var]
  .draw_triangle:
    push  ecx
    fninit
    movzx edx,word[esi]
    shl   edx,2
    lea   edx,[edx*3]
    mov   [first_p_index],edx
    add   edx,points_rotated
    fld   dword[edx]
;    fmul  [scale]
;    fiadd word[xxadd]
    fistp [.xx1]
    movzx eax,[.xx1]
    shl   eax,16
    fld   dword[edx+4]
;    fmul  [scale]
;    fiadd [yyadd]
    fistp [.yy1]
    mov   ax,[.yy1]
    fld   dword[edx+8]
;    fmul  [scale]
;    fiadd [zzadd]
    fist  word[zz1]
    fstp  [.zz1f]
					; z coord - skip
    movzx edx,word[esi+2]
    shl   edx,2
    lea   edx,[edx*3]
    mov   [second_p_index],edx
    add   edx,points_rotated
    fld   dword[edx]
;    fmul  [scale]
;    fiadd word[xxadd]
    fistp [.xx2]
    movzx ebx,[.xx2]
    shl   ebx,16
    fld   dword[edx+4]
;    fmul  [scale]
;    fiadd [yyadd]
    fistp [.yy2]
    mov   bx,[.yy2]
    fld   dword[edx+8]
;    fmul  [scale]
;    fiadd [zzadd]
    fist  [zz2]
    fstp  [.zz2f]

    movzx edx,word[esi+4]
    shl   edx,2
    lea   edx,[edx*3]
    mov   [third_p_index],edx
    add   edx,points_rotated
    fld   dword[edx]
;    fmul  [scale]
;    fiadd word[xxadd]
    fistp [.xx3]
    movzx ecx,[.xx3]
    shl   ecx,16
    fld   dword[edx+4]
;    fmul  [scale]
;    fiadd [yyadd]
    fistp [.yy3]
    mov   cx,[.yy3]
    fld   dword[edx+8]
;    fmul  [scale]
;    fiadd [zzadd]
    fist  [zz3]
    fstp  [.zz3f]

    mov     [.xy1],eax
    mov     [.xy2],ebx
    mov     [.xy3],ecx

    push  esi
    pushad

    cmp   [draw_flag],1
    je	  .flat_draw
    cmp   [draw_flag],3
    je	  .env_mapping
;    je    .flat_draw_float
;    cmp   [draw_flag],8
;    je    .flat_draw_float
    cmp   [draw_flag],4
    je	  .bump_mapping
    cmp   [draw_flag],5
    je	  .tex_mapping
    cmp   [draw_flag],8
    je	  .bump_tex_mapping
    cmp   [draw_flag],7
    je	  .two_tex
    cmp   [draw_flag],6
    je	  .grd_tex
    cmp   [draw_flag],9
    je	  .grd_line
    cmp   [draw_flag],10
    je	  .flat_draw_float
    cmp   [draw_flag],0
    je	  .draw_dots
    cmp   [draw_flag],11
    je	  .tex_line
    cmp   [draw_flag],12
    je	  .tex_line
    cmp   [draw_flag],13
    je	  .flat_line


     .grd_draw: 	       ;****Gouraud shading****
	fninit


	mov	esi,third_p_index
	mov	ecx,3
      .again_grd_draw:
	mov	eax,[esi]
	add	eax,points_normals_rotated
	fld	dword[eax]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.x_temp_var]	 ; x temp variables
	fld	dword[eax+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.y_temp_var]

	mov	eax,[.y_temp_var]
	shl	eax,TEX_SHIFT
	add	eax,[.x_temp_var]
	lea	eax,[4*eax+color_map]
	mov	eax,dword[eax]
	push	word[ecx*2+zz1-2]


	ror	 eax,16 	      ; eax -0xxxrrggbb -> 0xggbbxxrr
	xor	 ah,ah
	push	 ax	    ;r
	rol	 eax,8		      ; eax-0xggbb00rr -> 0xbb00rrgg
	xor	 ah,ah
	push	 ax	    ;g
	shr	 eax,24
	push	 ax	    ;b

	sub	 esi,4
	dec	 ecx
	jnz	 .again_grd_draw

if 0
   ; -----------version with only one light supported------
    mov   [.counter],4	    ; ++++ gouraud shading  ++++++++
  .calc_col_LVD:    ; calculate color Light Vector Depend
    mov   edx,[.counter]
    push  [zz1+edx]
; calc color of triangle light vector dependent
    mov   esi,light_vect
    mov   edi,points_normals_rotated
    add   edi,[first_p_index+2*edx]
    call  dot_product
    fst   [.dpr]	    ; orginal+specular*st+emmisive*st^5
    push  ecx		    ; o + min*st + max * st^5
    mov   ecx,5 	    ; shiness
  @@:
    fmul  st,st0
    loop  @b
    fstp  [.dpr_p]	    ; dot product powered
    pop   ecx


    movq      xmm0,[light_c_max]
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm3,[.dpr_p]
    shufps    xmm3,xmm3,0
    mulps     xmm3,xmm2

    movq      xmm0,[light_c_o]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm3,xmm2

    movq      xmm0,[light_c_min]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm4,[.dpr]
    shufps    xmm4,xmm4,0
    mulps     xmm2,xmm4
    addps     xmm3,xmm2

;    shufps    xmm3,xmm3,11000110b

    cvtps2dq  xmm3,xmm3
    packssdw  xmm3,xmm3
;    pmaxuw    xmm3,[minimum0]
;    pminuw    xmm3,[maximum255]

    movd      edx,xmm3
  ;  ror       edx,16
    push      edx
    psrldq    xmm3,4
    movd      edx,xmm3
    push      dx

    sub   [.counter],2
    cmp   [.counter],0
    jge   .calc_col_LVD


end if

    mov     eax,[.xy1]
    mov     ebx,[.xy2]
    mov     ecx,[.xy3]

    mov   esi,[Zbuffer_ptr]
    mov   edi,[screen_ptr]
    call  gouraud_triangle_z
    jmp   .end_draw

  .draw_dots:
	mov	edi,[screen_ptr]
	mov	eax,[.xy1]

;        mov     edx,[yres_var]
	cmp	ax,[yres_var]  ; SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	ror	eax,16

   ;     mov     edx,[xres_var]
	cmp	ax,[xres_var] ;dx ;SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	movzx	edx,[xres_var] ;SIZE_X
	ror	eax,16
	cwde
	mul	edx
	add	eax,ebx
	shl	eax,2
	add	eax,edi
	mov	dword[eax],-1
;------------------
	mov	eax,[.xy2]
 ;       mov     edx,[yres_var]
	cmp	ax,[yres_var] ;dx ;SIZE_Y
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	ror	eax,16
;        mov     edx,[xres_var]
	cmp	ax,[xres_var] ;dx ;SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	movzx	edx,[xres_var];SIZE_X
	ror	eax,16

	cwde
	mul	edx
	add	eax,ebx
	shl	eax,2
	add	eax,edi
	mov	dword[eax],-1

	mov	eax,[.xy3]
      ;  mov     edx,[yres_var]
	cmp	ax,[yres_var] ;dx ;SIZE_Y
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	ror	eax,16

    ;    mov     edx,[xres_var]
	cmp	ax,[xres_var] ;dx ;SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
     ;   mov     edx,SIZE_X
	ror	eax,16
	cwde
	mul	edx
	add	eax,ebx
	shl	eax,2
	add	eax,edi
	mov	dword[eax],-1

	jmp   .end_draw
  .grd_line:		    ;****Gouraud line****
	fninit


	mov	esi,third_p_index
	mov	ecx,3
      .again_grd_line_param:
	mov	eax,[esi]
	add	eax,points_normals_rotated
	fld	dword[eax]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.x_temp_var]	 ; x temp variables
	fld	dword[eax+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.y_temp_var]

	mov	eax,[.y_temp_var]
	shl	eax,TEX_SHIFT
	add	eax,[.x_temp_var]
	lea	eax,[4*eax+color_map]
	mov	eax,dword[eax]
	mov	[ecx*4+col1-4],eax

	sub	 esi,4
	dec	 ecx			; decode all 3 edges
	jnz	 .again_grd_line_param


	mov	edi,[screen_ptr]
	mov	esi,[Zbuffer_ptr]

	mov	eax,[col1]
	movzx	bx,al
	push	bx		  ; b
	movzx	bx,ah
	push	bx
	rol	eax,16
	xor	ah,ah
	push	ax
	push	word[zz1]

	mov	eax,[.xy1]
	ror	eax,16
	push	eax

	mov	eax,[col2]
	movzx	bx,al
	push	bx		  ; b
	movzx	bx,ah
	push	bx
	rol	eax,16
	xor	ah,ah
	push	ax
	push	[zz2]

	mov	 eax,[.xy2]
	ror	 eax,16
	push	 eax

	call	smooth_line	; draw only one edge

    jmp   .end_draw



  .tex_line:		    ;****textured line****



	cmp	[draw_flag],12
	je	@f

	fninit
	sub	esp,4
	mov	edx,[first_p_index]
	add	edx,points_normals_rotated    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp+2]
	jmp	.pushzbuff1
     @@:
	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]
     .pushzbuff1:
	push	word[zz1]

	mov	eax,[.xy1]
	ror	eax,16
	push	eax

	cmp	[draw_flag],12
	je	@f
	sub	esp,4
	mov	edx,[second_p_index]
	add	edx,points_normals_rotated    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp+2]
	jmp	.pushzbuff2
     @@:
	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]
     .pushzbuff2:

	push	[zz2]

	mov	 eax,[.xy2]
	ror	 eax,16
	push	 eax

	mov	edi,[screen_ptr]
	mov	esi,[Zbuffer_ptr]
	mov	edx,envmap
	cmp	[draw_flag],12
	jne	@f
	mov	edx,texmap
     @@:
	call	tex_line     ; draw only one edge

    jmp   .end_draw

  .flat_line:		     ;****simple line****
			     ; without z coord. interpolation

    mov 	eax,[.xy1]	; check if parameters exceedes screen area
    mov 	ecx,[.xy2]
    or		eax,ecx
    test	eax,80008000h
    jne 	.end_draw

    mov 	eax,[.xy1]	; check if parameters exceedes screen area
    mov 	ecx,[.xy2]
    cmp 	ax,[yres_var] ;SIZE_Y
    jg		.end_draw
    cmp 	cx,[yres_var] ;SIZE_Y
    jg		.end_draw
    ror 	eax,16
    cmp 	ax,[xres_var] ;SIZE_X
    jg		.end_draw
    ror 	ecx,16
    cmp 	cx,[xres_var] ;SIZE_X
    jg		.end_draw

	movzx	 ebx,[xres_var]
	mov	 [screen_width_var],ebx ;,XRES

	mov	 eax,[.xy1]
    ;    ror      eax,16
	movzx	 ebx,ax
	shr	 eax,16
	mov	 ecx,[.xy2]
   ;     ror      ecx,16
	movzx	 edx,cx
	shr	 ecx,16

	push	 [screen_ptr]
	pop	 [lbuffer_ptr]

	call	 linea

	jmp	.end_draw


    .grd_tex:

	fninit

	mov    eax,[third_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov	esi,third_p_index
	mov	ecx,3

      .again_grd_tex_draw:

	mov	eax,[esi]
	add	eax,points_normals_rotated
	fld	dword[eax]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.x_temp_var]	 ; x temp variables
	fld	dword[eax+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.y_temp_var]

	mov	eax,[.y_temp_var]
	shl	eax,TEX_SHIFT
	add	eax,[.x_temp_var]
	lea	eax,[4*eax+color_map]
	mov	eax,dword[eax]
	push	word[ecx*2+zz1-2]


	ror	 eax,16 	      ; eax -0xxxrrggbb -> 0xggbbxxrr
	xor	 ah,ah
	push	 ax	    ;r
	rol	 eax,8		      ; eax-0xggbb00rr -> 0xbb00rrgg
	xor	 ah,ah
	push	 ax	    ;g
	shr	 eax,24
	push	 ax	    ;b

	sub	 esi,4
	dec	 ecx
	jnz	 .again_grd_tex_draw


	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,[Zbuffer_ptr]
	mov	edx,texmap

	call	tex_plus_grd_triangle

	jmp    .end_draw



     .flat_draw:		     ;**************************                                     ; FLAT DRAWING
	fninit
	push	eax
	push	ebx
	push	ecx

	mov	eax,[first_p_index]
	add	eax,points_normals_rotated
	fld	dword[eax]
	mov	ebx,[second_p_index]
	add	ebx,points_normals_rotated
	fadd	dword[ebx]
	mov	ecx,[third_p_index]
	add	ecx,points_normals_rotated
	fadd	dword[ecx]

	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	dword[.x_temp_var] ;[esp-4]    ; x temp variables
	fld	dword[eax+4]	; y cooficient of normal vector
	fadd	dword[ebx+4]
	fadd	dword[ecx+4]
	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	dword[.y_temp_var];[esp-8]   ;  y
	mov	edx,[.x_temp_var]  ; dword[esp-8]
	shl	edx,TEX_SHIFT
	add	edx,[.y_temp_var] ;dword[esp-4]
	lea	eax,[4*edx+color_map]
	mov	edx,dword[eax]
	or	edx,0xff000000	 ; edx - color

	pop	ecx
	pop	ebx
	pop	eax

	mov	edi,[screen_ptr]
	mov	esi,[Zbuffer_ptr]
	push	word[zz3]
	push	word[zz2]
	push	word[zz1]

	call	flat_triangle_z

    jmp   .end_draw






    .env_mapping:
	push	[zz3]
	push	[zz2]
	push	word[zz1]
	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	[.counter],3
      @@:
	mov	edx,[esi+first_p_index]
	add	edx,points_normals_rotated    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	[.counter]
	jnz	@b

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,envmap
	mov	edx,[Zbuffer_ptr]
	call	tex_triangle_z

	jmp	.end_draw


 .flat_draw_float:
    push  [.zz3f]
    push  [.zz2f]
    push  [.zz1f]

; calc color of triangle light vector dependent

	fninit
	push	eax
	push	ebx
	push	ecx

	mov	eax,[first_p_index]
	add	eax,points_normals_rotated
	fld	dword[eax]
	mov	ebx,[second_p_index]
	add	ebx,points_normals_rotated
	fadd	dword[ebx]
	mov	ecx,[third_p_index]
	add	ecx,points_normals_rotated
	fadd	dword[ecx]

	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	dword[.x_temp_var] ;[esp-4]    ; x temp variables
	fld	dword[eax+4]	; y cooficient of normal vector
	fadd	dword[ebx+4]
	fadd	dword[ecx+4]
	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	dword[.y_temp_var];[esp-8]   ;  y
	mov	edx,[.x_temp_var]  ; dword[esp-8]
	shl	edx,TEX_SHIFT
	add	edx,[.y_temp_var] ;dword[esp-4]
	lea	eax,[4*edx+color_map]
	mov	edx,dword[eax]
	or	edx,0xff000000	 ; edx - color

	pop	ecx
	pop	ebx
	pop	eax



if 0
    mov   esi,light_vect
    mov   edi,points_normals_rotated
    add   edi,[first_p_index]
    call  dot_product
    fst   [.dpr]	    ; orginal+specular*st+emmisive*st^5
    push  ecx		    ; o + min*st + max * st^5
    mov   ecx,5 	    ; shiness
  @@:
    fmul  st,st0
    loop  @b
    fstp  [.dpr_p]	    ; dot product powered
    pop   ecx

    movq      xmm0,[light_c_max]
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm3,[.dpr_p]
    shufps    xmm3,xmm3,0
    mulps     xmm3,xmm2

    movq      xmm0,[light_c_o]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm3,xmm2

    movq      xmm0,[light_c_min]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm4,[.dpr]
    shufps    xmm4,xmm4,0
    mulps     xmm2,xmm4
    addps     xmm3,xmm2

    cvtps2dq  xmm3,xmm3
    packssdw  xmm3,xmm3
;    pmaxub    xmm3,[minimum0]
;    pminub    xmm3,[maximum255]
    packuswb  xmm3,xmm3
    movd      edx,xmm3
end if




    mov   esi,[Zbuffer_ptr]
    mov   edi,[screen_ptr]

    call  flat_triangle_z_float
    jmp     .end_draw
;end if

  .tex_mapping:
	push	[zz3]
	push	[zz2]
	push	word[zz1]
   ;  cmp    [hrt_flag],3          ; check tetrahedron object cause
   ;  je     @f
	mov    eax,[third_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

    .no_tetra:
	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,texmap
	mov	edx,[Zbuffer_ptr]
	call	tex_triangle_z

	jmp	.end_draw


    .bump_mapping:
	push	[Zbuffer_ptr]
	push	word[zz3]
	push	word[zz2]
	push	word[zz1]

	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	[.counter],3
      @@:
	mov	edx,[esi+first_p_index]
	add	edx,points_normals_rotated    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	[.counter]
	jnz	@b

	mov    eax,[third_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]
	mov	esi,envmap
	mov	edx,bump_map		;BUMP_MAPPING

	call	bump_triangle_z
	jmp    .end_draw

    .two_tex:		    ; double texture mapping

	push	[Zbuffer_ptr]
	push	word[zz3]
	push	word[zz2]
	push	word[zz1]

	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	[.counter],3
      @@:
	mov	edx,[esi+first_p_index]
	add	edx,points_normals_rotated    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	[.counter]
	jnz	@b

   ;  cmp    [hrt_flag],3          ; check tetrahedron object cause
   ;  je     @f

	mov    eax,[third_p_index]	; tex coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[second_p_index]	 ; tex coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[first_p_index]	; tex coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]



	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]
	mov	esi,envmap
	mov	edx,texmap

	call	two_tex_triangle_z
	jmp    .end_draw


    .bump_tex_mapping:

	mov    eax,[third_p_index]	; tex coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[second_p_index]	 ; tex coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[first_p_index]	; tex coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	push	texmap

	push	[Zbuffer_ptr]
	push	word[zz3]
	push	word[zz2]
	push	word[zz1]

	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	[.counter],3
      @@:
	mov	edx,[esi+first_p_index]
	add	edx,points_normals_rotated    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	[.counter]
	jnz	@b

    ; cmp    [hrt_flag],3          ; check tetrahedron object cause
    ; je     @f
	mov    eax,[third_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]




	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]
	mov	esi,envmap
	mov	edx,bump_map		;BUMP_MAPPING

	call	bump_tex_triangle_z


 .end_draw:

    popad
    pop   esi
    add   esi,6
;    cmp   dword[esi],-1
;    jnz   .draw_triangle
    pop    ecx
    dec    ecx
    jnz    .draw_triangle

    cmp  [hrt_flag],3	   ; write frame around current segment
    jl	 .no_rectangle
  @@:
    cmp  [current_seg],255
    jz	 .no_rectangle

    mov   esi,points_rotated
    movzx ebx,[current_seg]

    cmp   [hrt_flag],3
    jne   @f
    mov  eax,BSTEPS*BSTEPS*12
    jmp   .calc
  @@:
    cmp   [hrt_flag],4
    jne   @f
    mov   eax,[rot_pipe_points_number]
    shl   eax,2
    lea   eax,[eax*3]
    jmp   .calc
  @@:
    cmp   ebx,BPIPES ;-1
    jle   .only_pipes
    mov   eax,[rot_pipe_points_number]
    imul  eax,BPIPES*12
;    mul   edx
;    mov   ecx,ebx  ;[current_seg]
    sub   ebx,BPIPES
    imul  ebx,BSTEPS*BSTEPS*12
;  @@:
;    add   eax,BSTEPS*BSTEPS*12
;    loop  @b
    add    eax,ebx
    jmp   .skip_mul

  .only_pipes:
    mov   eax,[rot_pipe_points_number]
    shl   eax,2
    lea   eax,[eax*3]


 .calc:
    mul   ebx
 .skip_mul:
   add	 esi,eax
   movups xmm0,[esi]
   movups xmm1,[esi]
   add	  esi,12
   cmp	  [hrt_flag],3
   jg	  @f
   mov	  ecx,(BSTEPS*(BSTEPS))-1
   jmp	  .find
 @@:
   cmp	  [hrt_flag],4
   jg	  @f
   mov	  ecx,[rot_pipe_points_number]
   dec	  ecx
   jmp	  .find
 @@:
   cmp	  [current_seg],BPIPES
   jge	  @f
   mov	  ecx,[rot_pipe_points_number]
   dec	  ecx
   jmp	  .find
 @@:
   mov	  ecx,(BSTEPS*(BSTEPS))-1
 .find:
 @@:
   movups xmm2,[esi]
   maxps  xmm0,xmm2
   minps  xmm1,xmm2
   add	  esi,12
   sub	  ecx,1
   jnz	  @b
 ;  xmm0 - max
 ;  xmm1 - min
;   movss    xmm2,[scale]
;   shufps   xmm2,xmm2,0
;   mulps    xmm0,xmm2
;   mulps    xmm1,xmm2
 ;  cvtps2dq xmm0,xmm0
  ; cvtps2dq xmm1,xmm1
;   movdqu   xmm2,[xxadd]
;   paddd    xmm0,xmm2
;   paddd    xmm1,xmm2
   movups   xmm2,[max_clip_seg]
   movups   xmm3,[min_clip_seg]
   minps    xmm0,xmm2
   maxps    xmm1,xmm3
   cvtps2dq xmm0,xmm0
   cvtps2dq xmm1,xmm1
   movups   [cur_seg_max_rot],xmm0
   movups   [cur_seg_max_rot+12],xmm1



    ; max min coordinate should be normalized like whole object
    ; (witch is before rotating, rescaling and translating) in <-1.0 ; 1.0>


    .xsegmax equ [cur_seg_max_rot]
    .ysegmax equ [cur_seg_max_rot+4]
    .xsegmin equ [cur_seg_max_rot+12]
    .ysegmin equ [cur_seg_max_rot+16]

    movzx     eax,[xres_var]
    mov       [screen_width_var],eax ;,XRES

    mov      eax,[cur_seg_max_rot+12]	; xmin
    mov      ebx,[cur_seg_max_rot+16]	; ymin
    mov      edx,ebx			; ymin
    mov      ecx,[cur_seg_max_rot]	; xmax

    push     [screen_ptr]
    pop      [lbuffer_ptr]
    call     linea

    mov     eax,[cur_seg_max_rot]      ; x max
    mov     ebx,[cur_seg_max_rot+16]   ; y min
;    mov     ecx,[cur_seg_max_rot]      ; x max
    mov     ecx,eax
    mov     edx,[cur_seg_max_rot+4]    ; y max
    call    linea

    mov     eax,[cur_seg_max_rot]      ; x max
    inc     eax
    mov     ebx,[cur_seg_max_rot+16]   ; y min
;    mov     ecx,[cur_seg_max_rot]      ; x max
;    inc     ecx
    mov     ecx,eax
    mov     edx,[cur_seg_max_rot+4]    ; y max
    call    linea


    mov     eax,[cur_seg_max_rot]      ; x max
    add     eax,2
    mov     ebx,[cur_seg_max_rot+16]   ; y min
;    mov     ecx,[cur_seg_max_rot]      ; x max
;    add     ecx,2
    mov     ecx,eax
    mov     edx,[cur_seg_max_rot+4]    ; y max
    call    linea

    mov     eax,.xsegmin
    mov     ebx,.ysegmax
    mov     ecx,.xsegmax
    mov     edx,.ysegmax
    call    linea

    mov     eax,.xsegmin
    mov     ebx,.ysegmax
    mov     ecx,.xsegmin
    mov     edx,.ysegmin
    call    linea

    mov     eax,.xsegmin
    inc     eax
    mov     ebx,.ysegmax
;    mov     ecx,.xsegmin
;    inc     ecx
    mov     ecx,eax
    mov     edx,.ysegmin
    call    linea

    mov     eax,.xsegmin
    add     eax,2
    mov     ebx,.ysegmax
;    mov     ecx,.xsegmin
;    add     ecx,2
    mov     ecx,eax
    mov     edx,.ysegmin
    call    linea

 @@:
   .no_rectangle:
    popad

   ; invoke      MessageBox,[hwnd],STRdata,_tsc_title,MB_RTLREADING
;   invoke stop_ticks
ret

endp

normalize_all_light_vectors:
	mov	edi,lights
     @@:
	call	normalize_vector	   ;       3dmath.inc
	add	edi,LIGHT_SIZE
	cmp	edi,lightsend	;ecx
	jl	@b
ret
read_hrt:
	fninit
	mov    esi,hrt_triangles
	mov    edi,triangles
	cld
	mov    [triangles_count_var],hrt_triangles_count
	mov    ecx,hrt_triangles_count
     @@:
	movsd
	movsw
	loop   @b
	movsd	    ; copy end mark too


	mov    esi,hrt_points
	mov    edi,points_r
	mov    [points_count_var],0
      @@:
	fild   word[esi]
	fstp   dword[edi]
	fild   word[esi+2]
	fstp   dword[edi+4]
	fild   word[esi+4]
	fstp   dword[edi+8]
	inc    [points_count_var]
	add    edi,12
	add    esi,6
	cmp    dword[esi],-1
	jne    @b
	movsd	 ;copy  end mark too

ret

read_from_file:   ;; this procedure coded orginally by Madis Kalme
	fninit
    ;    mov     edi,[triangles_ptr]
	mov	edi,triangles
	xor	ebx,ebx
	xor	ebp,ebp
	mov	[points_count_var],0
	mov	[triangles_count_var],0

	mov	esi,[File_ptr]

	cmp	[esi],word 4D4Dh
	jne	.exit ;Must be legal .3DS file
;        cmp     dword[esi+2],EndFile-SourceFile
;        jne     .exit ;This must tell the length
	mov	eax,dword[esi+2]
  ;      cmp     eax,[fsize]
  ;      jne     .exit

	add	eax,esi
	mov	[EndFile],eax	 ;

	add	esi,6
      @@:
	cmp	[esi],word 3D3Dh
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      .find4k:
	cmp	[esi],word 4000h
	je	@f
	add	esi,[esi+2]
	cmp	esi,[EndFile]
	jc	.find4k
	jmp	.exit
      @@:
	add	esi,6
      @@:
	cmp	[esi],byte 0
	je	@f
	inc	esi
	jmp	@b
      @@:
	inc	esi
      @@:
	cmp	[esi],word 4100h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      @@:
	cmp	[esi],word 4110h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	[points_count_var],cx

	mov	edx,ecx
	add	esi,8
     @@:
	push	edi
    ;    mov     edi,[points_ptr]
	mov	edi,points_r
	push	dword[esi+0]
	pop	dword[edi+ebx*2+0]
	push	dword[esi+4]
	pop	dword[edi+ebx*2+4]
	push	dword[esi+8]
	pop	dword[edi+ebx*2+8]
	pop	edi

	add	ebx,6
	add	esi,12
	dec	ecx
	jnz	@b
      @@:
  ;      mov     dword[points+ebx],-1
	push	edi
    ;    mov     edi,[points_ptr]
	mov	edi,points_r
	mov	dword[edi+ebx*2],-1	   ; end mark (not always in use)
	pop	edi
      @@:
	cmp	[esi],word 4120h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	[triangles_count_var],cx
	add	esi,8
	;mov     edi,triangles
      @@:
	movsd
	movsw
	add	word[edi-6],bp
	add	word[edi-4],bp
	add	word[edi-2],bp
	add	esi,2
	dec	ecx
	jnz	@b
	add	ebp,edx
	jmp	.find4k
	mov	eax,-1 ;<---mark if OK
      .exit:
	mov	dword[edi],-1
ret

init_triangles_normals2:
	fninit
    ;    mov     ebx,[triangles_normals_ptr]
	mov	ebx,triangles_normals
    ;    mov     ebp,[triangles_ptr]
	mov	ebp,triangles
	movzx	ecx,[triangles_count_var]
     @@:
	push	ecx
	push	ebx
	mov	ebx,vectors
	movzx	esi,word[ebp]	       ; first point index
	lea	esi,[esi*3]
    ;    lea     esi,[points+esi*2]     ; esi - pointer to 1st 3d point
	shl	esi,2
	add	esi,points_r
	movzx	edi,word[ebp+2] 	 ; first point index
	lea	edi,[edi*3]
	shl	edi,2
  ;      add     edi,[points_ptr]
	add	edi,points_r
;        movzx   edi,word[ebp+2]        ; second point index
;        lea     edi,[edi*3]
;        lea     edi,[points+edi*2]     ; edi - pointer to 2nd 3d point

	call	make_vector_r
	add	ebx,12
	mov	esi,edi
	movzx	edi,word[ebp+4]        ; third point index
	lea	edi,[edi*3]
	shl	edi,2
      ;  add     edi,[points_ptr]
	add	edi,points_r
;        lea     edi,[points+edi*2]
	call	make_vector_r
	mov	edi,ebx 		; edi - pointer to 2nd vector
	mov	esi,ebx
	sub	esi,12			; esi - pointer to 1st vector
	pop	ebx
	call	cross_product
	mov	edi,ebx
	call	normalize_vector
	add	ebp,6
	add	ebx,12
	pop	ecx
	loop	@b
    ;    cmp     dword[ebp],-1
      ;  jne     @b
ret

init_point_normals:
.x equ dword [ebp-4]
.y equ dword [ebp-8]
.z equ dword [ebp-12]
.point_number equ word [ebp-26]
.hit_faces    equ word [ebp-28]

	fninit
	mov	  ebp,esp
	sub	  esp,28
	mov	  edi,points_normals ;[points_normals_ptr]
	mov	  .point_number,0
    .ipn_loop:
	mov	  .hit_faces,0
	mov	  .x,0
	mov	  .y,0
	mov	  .z,0
	mov	  esi,triangles;[triangles_ptr]
	xor	  ecx,ecx	       ; ecx - triangle number
    .ipn_check_face:
	xor	  ebx,ebx	       ; ebx - 'position' in one triangle
    .ipn_check_vertex:
	movzx	  eax,word[esi+ebx]    ;  eax - point_number
	cmp	  ax,.point_number
	jne	  .ipn_next_vertex
	push	  esi
	mov	  esi,ecx
	lea	  esi,[esi*3]
       ; lea       esi,[triangles_normals+esi*4]
	shl	  esi,2
	add	  esi,triangles_normals ;[triangles_normals_ptr]

	fld	  .x
	fadd	  dword[esi]
	fstp	  .x
	fld	  .y
	fadd	  dword[esi+4]
	fstp	  .y
	fld	  .z
	fadd	  dword[esi+8]
	fstp	  .z
	pop	  esi
	inc	  .hit_faces
	jmp	  .ipn_next_face
    .ipn_next_vertex:
	add	  ebx,2
	cmp	  ebx,6
	jne	  .ipn_check_vertex
    .ipn_next_face:
	add	  esi,6
	inc	  ecx
	cmp	  cx,[triangles_count_var]
	jne	  .ipn_check_face

	fld	  .x
	fidiv	  .hit_faces
	fstp	  dword[edi]
	fld	  .y
	fidiv	  .hit_faces
	fstp	  dword[edi+4]
	fld	  .z
	fidiv	  .hit_faces
	fstp	  dword[edi+8]
	call	  normalize_vector
	add	  edi,12  ;type vector 3d
	inc	  .point_number
	mov	  dx,.point_number
	cmp	  dx,[points_count_var]
	jne	  .ipn_loop

	mov	  esp,ebp
ret

include 'grd_cat.inc'
include 'tex_cat.inc'
include 'flat_cat.inc'
if Ext >= AVX
  include 'flat_cat_floatZavx.inc'
else
  include 'flat_cat_floatZ.inc'
end if
include '3DMATH.INC'
include 'procs_a.inc'
include 'bump_cat.inc'
include 'bump_tex.inc'
include 'two_tex.inc'
include 'grd_tex.inc'
include 'grd_line.inc'
include 'tex_line.inc'
include 'line.inc'

include 'b_curve.inc'
;include 'Bline.inc'
include 'arbitrary_vector.inc'
include 'matrix.inc'
include 'rotated_bezier.inc'
;include 'b_surface.inc'
include 'asc.inc'
include 'asc_header.inc'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
section '.data' data readable writeable
    _class     TCHAR	 'grtest',0
    _title     TCHAR	 'Ave Cruce Salus Mea'
  if Ext = SSE2
     .exxt     TCHAR	 ' SSE2'
  else if Ext = SSE3
     .exxt     TCHAR	 ' SSE3'
  else if Ext = SSE4.1
     .exxt     TCHAR	 ' SSE4.1'
  else if Ext = AVX
     .exxt     TCHAR	 ' AVX'
  end if
  fakebitmap   dd  0,0,0,0
    .end TCHAR 0
    _error     TCHAR	 'Startup failed.',0
    _tsc_title TCHAR	 'Clocks number',0
    sh_model   TCHAR	 'Nodes of object                     '
	.fl    TCHAR	 'Flat Shading                        '
	.gr    TCHAR	 'Gouraud Shading                     '
	.sp    TCHAR	 'Spherical Environment Mapping       '
	.bm    TCHAR	 'Bump Mapping                        '
	.tx    TCHAR	 'Texture Maping                      '
	.grtx  TCHAR	 'Gouraud Shading and Texture Mapping '
	.dtxx  TCHAR	 'Double Texture Mapping              '
	.bmtx  TCHAR	 'Bump and Texture Mapping Pararell   '
	.grl   TCHAR	 'Gouraud Shaded Line                 '
	.flf   TCHAR	 'Flat Shading with Float zBuffer     '
	.txl   TCHAR	 'Textured Line - Env. Mapping        '
	.tx12  TCHAR	 'Textured Line                       '
	.line  TCHAR	 'Simple line without z coord. interp.'

;    no_display  dw 11    ; Number of displaying models    '

    File_ptr	 dd ?
    File_tex_ptr dd ?
    SourceFile:
;    file        'knot.3ds'
    EndFile	dd ?
    asc_file_name db 'object.asc'
    up		dd 0
    s_time	dd 0
    e_time	dd 0
    num_animations dd 3
    ccounter	   dd 0
    ccounter_inc   dd 1
    screen_width_var dd ?  ; SIZE_X
;    line_buffer_var dd buffer
    triangles_count_var  dw TRIANGLES_COUNT
    points_count_var	 dw POINTS_COUNT

    convert_muler:
    dd 1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000
    XYZpartices:
    db 'X','Y','Z'
    i10 dw 10




    tex_x_div2	dd  TEX_X / 2
    tex_y_div2	dd  TEX_Y / 2
    i3		dd  3
    i2		dd  2
    i6		dd  6
    i12 	dd  12
    i24 	dd  24
    i36 	dd  36
    i180	dw  180
    i256	dw  256
    i255d	dd  255
    env_const	dd  1.05
    dot_max	dd  1.0
    dot_min	dd  0.0
    correct_tex dw  255
    displac_div dd  5800 ;* 3 ; displacement divisior


    scale	dd 200.0
    scale_plus	dd 1.2
    scale_minus dd 0.8
    xxadd:
		dd   ?	;XRES/2
    yyadd	dd   ?	;YRES/2
    zzadd	dd 1000
    seg_rot_flag_button_down db 0
    tex_button_pres db 0
    current_seg_add_flag db 0
    draw_flag	db 1
    blur_flag	db 0
    hrt_flag	db 0
    map_flag	db 0
    bump_flag	db 0
    tex_flag	db 0
    rotary_flag db 0
;    lbuffer_ptr dd buffer
    piD128:
    one_deg	dd   0.024543692
    STRdata	db   '-1        '
    main_rotary :
	       dd 0
	       dd 0
	       dd 0
    all_lights_size dw lightsend-lights

  lights:
    light_vect	dd   0.0,0.0,-1.0
    light_c_o:			   ;   +12
       dw   1,1,1,0
    light_c_min:		   ;   +20
       dw   1,1,1,0
    light_c_max:		   ;   +28
       dw   255,255,5,0
    shiness:
       dw   5			   ;   +36
    LIGHT_SIZE = ($-lights)
       dd   -0.5,-0.5,-1.0
			 ;   +12
       dw   1,255,1,0
			 ;   +20
       dw   1,1,1,0
			 ;   +28
       dw   255,255,255,0
       dw   5		 ;   +36

       dd   0.5,0.5,-1.0
				   ;   +12
       dw   13,1,1,0
				   ;   +20
       dw   70,30,70,0
				   ;   +28
       dw   25,255,255,0
       dw   5			   ;   +36
   lightsend:


 align 16
    minimum0:
       dw   0,0,0,0,0,0,0,0
    maximum255:
       dw   255,255,255,255,255,255,255,255
 align 16
    mask_blend:
       dd -1,-1,-1,-1
    tex_cutter:
       dd TEXTURE_SIZE, TEXTURE_SIZE, TEXTURE_SIZE, TEXTURE_SIZE
    blur_sub:
       dd 0x01010101, 0x01010101, 0x01010101, 0x01010101
 align 16
    muler1234:
       dd 1.0
       dd 2.0
       dd 3.0
       dd 4.0
align 16
    muler0_7:
    muler0123:
       dd 0.0
       dd 1.0
       dd 2.0
       dd 3.0
       dd 4.0
       dd 5.0
       dd 6.0
       dd 7.0
align 16
mask_line:
	   dq 0xffffffff00ffffff
	   dq 0xffffffffffffffff

filter	   TCHAR   '3ds objects (*.3ds)',0,'*.3ds',0,\
		   'asc objects (*.asc)',0,'*.asc',0,\
		   'All files (*.*)',0,'*.*',0,0
_not3ds    TCHAR   'Not an 3d object file or read error.',0
_notraw    TCHAR   'Not an RAW 512X512 file or read error.',0
filter_tex TCHAR   'raw file 512X512 (*.raw)',0,'*.raw',0,\
		   'All files (*.*)',0,'*.*',0,0






; Sanctssimi Cordis Christi section
   hrt_points:
;cordis
dw 125,175,0, 175,175,0, 212,212,0, 250,175,0, 300,175,0, 325,200,0, 325,250,0
dw 300,300,0, 212,350,0, 125,300,0, 100,250,0, 100,200,0,175,250,-20,250,250,-20
;crux
dw 175,125,0, 200,125,0, 200,100,0, 225,100,0, 225,125,0, 250,125,0, 250,150,0
dw 225,150,0, 225,200,0, 200,200,0, 200,150,0, 175,150,0
;cordis next layer
dw 125,175,20, 175,175,20, 212,212,20, 250,175,20, 300,175,20, 325,200,20
dw 325,250,20, 300,300,20, 212,350,20, 125,300,20, 100,250,20, 100,200,20
dw 175,250,40, 250,250,40
;crux
dw 175,125,20, 200,125,20, 200,100,20, 225,100,20, 225,125,20, 250,125,20
dw 250,150,20, 225,150,20, 225,200,20, 200,200,20, 200,150,20, 175,150,20
;crown
dw 50,250,-25, 50,250,25, 100,250,75, 175,250,100,  275,250,100, 350,250,75
dw 380,250,25, 380,250,-25,350,250,-75,275,250,-100,175,250,-100, 100,250,-75
dw 50,265,-25, 100,265,75, 275,265,100,380,265,25,  350,265,-75, 175,265,-100
;thorns
dw 50,250,-50, 75,260,103, 275,240,150, 365,250,25, 350,260,-41, 150,240,-125

	hrt_points_count = ($-hrt_points)/6
dd -1
    hrt_triangles:
dw 1,0,12, 2,1,12, 9,8,12, 10,9,12, 11,10,12, 0,11,12, 12,13,2, 13,12,8, 3,2,13
dw 4,3,13, 5,4,13, 6,5,13, 7,6,13, 8,7,13
;crux
dw 22,21,23, 24,23,21, 25,24,14, 14,24,18, 18,24,20, 19,18,20, 16,15,18
dw 17,16,18
;cordis next layer
dw 26,27,38, 27,28,38, 34,35,38, 35,36,38, 36,37,38, 37,26,38, 38,39,34, 28,29,39
dw 29,30,39, 30,31,39, 31,32,39, 32,33,39, 33,34,39, 39,38,28
; crux next layer
dw 47,48,49, 49,50,47, 50,51,40, 50,40,44, 50,42,44
dw 42,43,44, 46,50,44, 44,45,46
;border cordis
dw 0,1,26, 1,27,26, 1,2,27, 28,27,2, 2,3,28, 29,28,3, 3,4,29, 30,29,4, 4,5,30
dw 31,39,5, 5,6,31, 32,31,6, 6,7,32, 33,32,7, 7,8,33, 34,33,8, 8,9,34, 35,34,9
dw 9,10,35, 36,35,10, 10,11,36, 37,36,11, 11,0,37, 37,26,0, 0,38,37
;border crux
dw 14,15,40, 41,40,15, 15,16,41, 42,41,16, 16,17,42, 43,42,17, 17,18,43
dw 44,43,18, 18,19,44, 45,44,19, 19,20,45, 46,45,20, 20,21,46, 47,46,21
dw 21,22,47, 48,47,22, 23,24,49, 50,49,24, 24,25,50, 51,50,25, 25,14,51
dw 14,40,51
;crown
dw 52,53,64, 53,54,65, 54,55,65, 55,56,66, 56,57,66, 57,58,67, 58,59,67
dw 59,60,68, 60,61,68, 61,62,69, 62,63,69, 63,64,52
;thorns
dw 52,64,70, 54,65,71, 56,66,72, 58,67,73, 68,60,74, 69,62,75
	hrt_triangles_count = ($-hrt_triangles)/6
dd -1
;box


tetra_points_r:
dd -1.0, -1.0, 1.0
dd  1.0, -1.0, 1.0
dd  0.0,  1.0, 0.0
dd  0.0, -1.0,-1.0
tetra_points_count = 4
dd -1 ;<- end marker

tetra_triangles:
dw 0,1,2, 2,3,0, 2,1,3,  1,0,3
tetra_triangles_count = 4
dd -1 ;<- end marker
tetra_tex_points:
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dd -1
current_seg db 0      ; 255 - no segment selected
;segments_rotary:
;    dd 0  ; x ; angles (in degrees) rotary single Bezier segment
;    dd 0  ; y
;    dd 0  ; z
max_clip_seg:
    dd ?  ;XRES - 3
    dd ?  ;YRES - 3
min_clip_seg:
    dd 1.0
    dd 1.0
current_seg_add:
    dd 0       ; x ,y ,z
    dd 0
    dd 0
current_seg_add_start:
    dd 0
    dd 0
    dd 0
seg_backward_rot:
    dd 0
    dd 0
    dd 0
maxscaleseg dd 1.0
allsegcenter:
    dd 0, 0, 0, 0
rot_pipe_points_number dd  0

if 0
segments_add:
    dd 10
    dd 10
    dd 10
    dd 260
    dd 260
    dd 10
    dd 50
    dd 60
    dd 80
end if
include  'b_rot_var_init.inc'
;include  'b_surface_data.inc'


    msg     MSG
    rect    RECT
    ofn     OPENFILENAME sizeof.OPENFILENAME,0,0,filter,0,0,0,fname,260 ;MAXSIZE
    ofntex  OPENFILENAME sizeof.OPENFILENAME,0,0,filter_tex,0,0,0,fnametex,260 ;MAXSIZE
    wc WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,1,NULL,_class
    ps PAINTSTRUCT

      ; single pipe points count
    xres_var	    dw ?
    yres_var	    dw ?
    screen_ptr	    dd ?
    Zbuffer_ptr     dd ?
    line_buffer_var dd ?
    heap_start_ptr  dd ?
    lbuffer_ptr     dd ?
    segments_add:
	      rd BSEGMENTS*3
    segments_rotary:
	      rd BSEGMENTS*3	; x ; angles (in degrees) rotary single Bezier segment
  ;  cur_seg_max:       ; current edited (rotary) bezier segment min and max coordinate
  ;            rd 3
  ;  cur_seg_min:
  ;            rd 3
  ;            rd 1   ; 4 byte space
    cur_seg_max_rot:
	      rd 8
    cur_seg_center:
	      rd 4
    center_scale:
	      rd 4
    max_scale dd ?
    tex_mov_begin_x:
		     dw ? ;  \ dont change order
    tex_mov_begin_y  dw ? ;  /
 ;   sinx      dd ?
 ;   cosx      dd ?
 ;   siny      dd ?
 ;   cosy      dd ?
 ;   sinz      dd ?
 ;   cosz      dd ?
 ;   matrix    rb 36
    file_ext_flag  db ?   ; 0 - 3ds, 1 - asc
    fname     rb      260 ;MAXSIZE
    fnametex  rb      260
    BytesRead dd ?
    hfile     dd ?
    hfiletex  dd ?
    FileSize  dd ?
    byteswritten  dd ?
    hheap     dd ?
    pmem      dd ?
    pmemtex   dd ?
    first_p_index:
		   dd ?
    second_p_index dd ?
    third_p_index  dd ?   ; don't change order
align 16
    cos_x:
		  rd 1
    sin_x	  dd ?
    neg_cos_x	  dd ?
    neg_sin_x	  dd ?
;align 16
    cos_y:
		  rd 1
    sin_y	  dd ?
    neg_cos_y	  dd ?
    neg_sin_y	  dd ?
;align 16
    cos_z:
		  rd 1
    sin_z	  dd ?
    neg_cos_z	  dd ?
    neg_sin_z	  dd ?

    rand_seed dw ?
    hwnd      dd ?
    hdc       dd ?
    bmi      BITMAPINFOHEADER
    align 16
    sse_repository:
       rd 512
  align 16
    asc_file_buffer  rd 65536 * 8
;    buffer    rd XRES * YRES
;    Zbuffer   rd XRES * YRES
    bump_map  rb TEX_X * TEX_Y
    envmap    rd TEX_X * TEX_Y
    color_map rd TEX_X * TEX_Y
    texmap    rd TEX_X * TEX_Y
    points_rotated rb 65536 * 12 ;1000000
    tex_points	rb 65536 * 12	    ; bump_map  and texture coords
				; each point word x, word y
    hrt_points_r:
       rb 1000000
    points_r:
       rb 65536 * 12 ;1000000
    triangles:
       rb 65536 * 12 ;1000000
    triangles_normals:
       rb 65536 * 12 ;1000000
    points_normals:
       rb 65536 * 12 ;1000000
    points_normals_rotated:
       rb 65536 * 12 ;1000000



    col1:
		   dd ?
    col2	   dd ?
    col3	   dd ?
    zz1:
	dw ?
    zz2 dw ?
    zz3 dw ? ;-> don't change order

    vectors rb 24
    angles  rb 24
    matrix  rb 36
    cos_tab rd 360
    sin_tab rd 360
include  'b_rot_var_uninit.inc'


section '.idata' import data readable writeable
    library kernel32,'KERNEL32',\user32,'USER32',\gdi32,'GDI32',\winmm,'WINMM',\
    comdlg32,'COMDLG32'    ;   timing,'timing.dll'
    include '\include\api\kernel32.inc'
    include '\include\api\user32.inc'
    include '\include\api\gdi32.inc'
    include '\include\api\comdlg32.inc'
 ;   include 'timing.inc'
;    import winmm,timeGetTime,'timeGetTime'




